"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var client = require("./client");
var BaseAction = (function () {
    function BaseAction() {
        this.beforeChangeHandlers = [];
        this.afterChangeHandlers = [];
    }
    BaseAction.prototype.onChanged = function (handler) {
        this.afterChangeHandlers.push(handler);
    };
    BaseAction.prototype.onBeforeChange = function (handler) {
        this.beforeChangeHandlers.push(handler);
    };
    BaseAction.prototype.fireOnBeforeChange = function (issue) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, before;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _i = 0, _a = this.beforeChangeHandlers;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        before = _a[_i];
                        return [4 /*yield*/, before(issue)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    BaseAction.prototype.fireOnChanged = function (issue) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, after;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _i = 0, _a = this.afterChangeHandlers;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        after = _a[_i];
                        return [4 /*yield*/, after(issue)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return BaseAction;
}());
exports.BaseAction = BaseAction;
var BaseIssueAction = (function (_super) {
    __extends(BaseIssueAction, _super);
    function BaseIssueAction(issue) {
        var _this = _super.call(this) || this;
        _this.issue = issue;
        return _this;
    }
    BaseIssueAction.prototype.fireOnBeforeChange = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.fireOnBeforeChange.call(this, this.issue)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseIssueAction.prototype.fireOnChanged = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.fireOnChanged.call(this, this.issue)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return BaseIssueAction;
}(BaseAction));
exports.BaseIssueAction = BaseIssueAction;
var Labels;
(function (Labels) {
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(issue, labels) {
            var _this = _super.call(this, issue) || this;
            _this.labels = labels;
            return _this;
        }
        return Base;
    }(BaseIssueAction));
    Labels.Base = Base;
    var Add = (function (_super) {
        __extends(Add, _super);
        function Add() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Add.prototype, "summary", {
            get: function () {
                return "Add labels " + JSON.stringify(this.labels) + " to issue " + this.issue.number;
            },
            enumerable: true,
            configurable: true
        });
        Add.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                var labelsToAdd;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            labelsToAdd = this.labels.filter(function (lab) { return !_this.issue.hasLabel(lab); });
                            if (labelsToAdd.length === 0)
                                return [2 /*return*/];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.addLabels(this.issue, labelsToAdd)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Add;
    }(Base));
    Labels.Add = Add;
    var Remove = (function (_super) {
        __extends(Remove, _super);
        function Remove() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Remove.prototype, "summary", {
            get: function () {
                return "Remove labels " + JSON.stringify(this.labels) + " to issue " + this.issue.number;
            },
            enumerable: true,
            configurable: true
        });
        Remove.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                var labelsToRemove;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            labelsToRemove = this.labels.filter(function (lab) { return _this.issue.hasLabel(lab); });
                            if (labelsToRemove.length === 0)
                                return [2 /*return*/];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.removeLabels(this.issue, this.labels)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Remove;
    }(Base));
    Labels.Remove = Remove;
    var Set = (function (_super) {
        __extends(Set, _super);
        function Set() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Set.prototype, "summary", {
            get: function () {
                return "Apply label set " + JSON.stringify(this.labels) + " to issue " + this.issue.number;
            },
            enumerable: true,
            configurable: true
        });
        Set.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                var desired, actual;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            desired = this.labels.slice().sort();
                            actual = this.issue.labels.map(function (l) { return l.name; }).sort();
                            if (JSON.stringify(desired) === JSON.stringify(actual)) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.setLabels(this.issue, this.labels)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Set;
    }(Base));
    Labels.Set = Set;
})(Labels = exports.Labels || (exports.Labels = {}));
var Comments;
(function (Comments) {
    function parseHeader(body) {
        var regex = /^<!--header (.*) headerend-->/g;
        var match = regex.exec(body);
        return match ? JSON.parse(match[1]) : undefined;
    }
    function makeHeader(header) {
        return "<!--header " + JSON.stringify(header) + " headerend-->";
    }
    function makeFooter() {
        return "<!--footer bot @ " + (new Date()).toLocaleString() + " footerend-->";
    }
    function makeComment(slug, body) {
        return makeHeader({ slug: slug }) + '\r\n' + body + '\r\n' + makeFooter();
    }
    function getBody(comment) {
        var regex = /headerend-->\r?\n(.*)\r?\n<!--footer/;
        var match = regex.exec(comment.body);
        if (match) {
            return match[1];
        }
        return comment.body;
    }
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(issue, slug) {
            var _this = _super.call(this, issue) || this;
            _this.slug = slug;
            return _this;
        }
        return Base;
    }(BaseIssueAction));
    Comments.Base = Base;
    var Add = (function (_super) {
        __extends(Add, _super);
        function Add(issue, slug, body) {
            var _this = _super.call(this, issue, slug) || this;
            _this.body = body;
            return _this;
        }
        Object.defineProperty(Add.prototype, "summary", {
            get: function () {
                return "Write comment (slug '" + this.slug + "') on issue " + this.issue.number;
            },
            enumerable: true,
            configurable: true
        });
        Add.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                var me, comments, _i, comments_1, c, header, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, client.getMyLogin()];
                        case 1:
                            me = _a.sent();
                            return [4 /*yield*/, this.issue.getComments()];
                        case 2:
                            comments = (_a.sent()).filter(function (c) { return c.user.login === me; });
                            _i = 0, comments_1 = comments;
                            _a.label = 3;
                        case 3:
                            if (!(_i < comments_1.length)) return [3 /*break*/, 9];
                            c = comments_1[_i];
                            header = parseHeader(c.body);
                            if (!(header && (header.slug === this.slug))) return [3 /*break*/, 8];
                            body = getBody(c);
                            if (!(body !== this.body)) return [3 /*break*/, 7];
                            console.log('Actual: ' + body);
                            console.log('Desired: ' + this.body);
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 4:
                            _a.sent();
                            return [4 /*yield*/, client.editComment(c, makeComment(this.slug, this.body))];
                        case 5:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 6:
                            _a.sent();
                            _a.label = 7;
                        case 7: return [2 /*return*/];
                        case 8:
                            _i++;
                            return [3 /*break*/, 3];
                        case 9: return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 10:
                            _a.sent();
                            return [4 /*yield*/, client.addComment(this.issue, makeComment(this.slug, this.body))];
                        case 11:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 12:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Add;
    }(Base));
    Comments.Add = Add;
})(Comments = exports.Comments || (exports.Comments = {}));
var Assignees;
(function (Assignees) {
    var Base = (function (_super) {
        __extends(Base, _super);
        function Base(issue, assignees) {
            var _this = _super.call(this, issue) || this;
            _this.assignees = assignees;
            return _this;
        }
        return Base;
    }(BaseIssueAction));
    Assignees.Base = Base;
    var Add = (function (_super) {
        __extends(Add, _super);
        function Add() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Add.prototype, "summary", {
            get: function () {
                return "Assign issue " + this.issue.fullName + " to " + JSON.stringify(this.assignees);
            },
            enumerable: true,
            configurable: true
        });
        Add.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    throw new Error('Not implemented');
                });
            });
        };
        return Add;
    }(Base));
    Assignees.Add = Add;
})(Assignees = exports.Assignees || (exports.Assignees = {}));
var Issues;
(function (Issues) {
    var SetColumn = (function (_super) {
        __extends(SetColumn, _super);
        function SetColumn(issue, project, column) {
            var _this = _super.call(this, issue) || this;
            _this.project = project;
            _this.column = column;
            return _this;
        }
        Object.defineProperty(SetColumn.prototype, "summary", {
            get: function () {
                return "Move issue " + this.issue.fullName + " to column " + (this.column ? this.column.name : '(none)') + " in project " + this.project.projectId;
            },
            enumerable: true,
            configurable: true
        });
        SetColumn.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.project.doSetIssueColumn(this.issue, this.column)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return SetColumn;
    }(BaseIssueAction));
    Issues.SetColumn = SetColumn;
    var Lock = (function (_super) {
        __extends(Lock, _super);
        function Lock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Lock.prototype, "summary", {
            get: function () {
                return "Lock issue " + this.issue.fullName;
            },
            enumerable: true,
            configurable: true
        });
        Lock.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.issue.locked)
                                return [2 /*return*/];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.lockIssue(this.issue)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Lock;
    }(BaseIssueAction));
    Issues.Lock = Lock;
    var Unlock = (function (_super) {
        __extends(Unlock, _super);
        function Unlock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Unlock.prototype, "summary", {
            get: function () {
                return "Unlock issue " + this.issue.fullName;
            },
            enumerable: true,
            configurable: true
        });
        Unlock.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.issue.locked)
                                return [2 /*return*/];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.unlockIssue(this.issue)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Unlock;
    }(BaseIssueAction));
    Issues.Unlock = Unlock;
    var Close = (function (_super) {
        __extends(Close, _super);
        function Close() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Close.prototype, "summary", {
            get: function () {
                return "Close issue " + this.issue.fullName;
            },
            enumerable: true,
            configurable: true
        });
        Close.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.issue.state === 'open')) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.closeIssue(this.issue)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        return Close;
    }(BaseIssueAction));
    Issues.Close = Close;
    var Reopen = (function (_super) {
        __extends(Reopen, _super);
        function Reopen() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(Reopen.prototype, "summary", {
            get: function () {
                return "Reopen issue " + this.issue.fullName;
            },
            enumerable: true,
            configurable: true
        });
        Reopen.prototype.execute = function (info) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.issue.state === 'closed')) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.fireOnBeforeChange()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, client.reopenIssue(this.issue)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.fireOnChanged()];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        return Reopen;
    }(BaseIssueAction));
    Issues.Reopen = Reopen;
})(Issues = exports.Issues || (exports.Issues = {}));
