"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var client = require("./client");
var github_1 = require("./github");
var logging_1 = require("./logging");
var log = logging_1.Cache.log;
function syncRepoCache(cache, repo) {
    return __awaiter(this, void 0, void 0, function () {
        /**
         * Returns true if the cache is OK, false if we need to full-fetch
         */
        function updateCache() {
            return __awaiter(this, void 0, void 0, function () {
                var now, page1, lastWasUpToDate, _i, page1_1, issue, key, cached;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            now = new Date();
                            return [4 /*yield*/, client.fetchChangedIssuesRaw(repo)];
                        case 1:
                            page1 = _a.sent();
                            lastWasUpToDate = false;
                            _i = 0, page1_1 = page1;
                            _a.label = 2;
                        case 2:
                            if (!(_i < page1_1.length)) return [3 /*break*/, 7];
                            issue = page1_1[_i];
                            key = github_1.IssueOrPullRequest.getCacheKey(repo, issue.number, !!issue.pull_request);
                            return [4 /*yield*/, cache.load(key)];
                        case 3:
                            cached = _a.sent();
                            if (!(cached.exists && Date.parse(cached.timestamp) >= Date.parse(issue.updated_at))) return [3 /*break*/, 4];
                            // Already up to date, we can stop
                            return [2 /*return*/, true];
                        case 4: return [4 /*yield*/, saveIssueOrPR(issue, now)];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6:
                            _i++;
                            return [3 /*break*/, 2];
                        case 7: 
                        // Got here, which means we ran off the page without hitting an up-to-date entry
                        return [2 /*return*/, false];
                    }
                });
            });
        }
        function saveIssueOrPR(issue, now) {
            return __awaiter(this, void 0, void 0, function () {
                var key, pr;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            key = github_1.IssueOrPullRequest.getCacheKey(repo, issue.number, !!issue.pull_request);
                            if (!!!issue.pull_request) return [3 /*break*/, 3];
                            return [4 /*yield*/, client.fetchPR(repo, issue.number)];
                        case 1:
                            pr = _a.sent();
                            return [4 /*yield*/, cache.save(pr, key, now)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, cache.save(issue, key, now)];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5: return [2 /*return*/];
                    }
                });
            });
        }
        function fullFetch() {
            return __awaiter(this, void 0, void 0, function () {
                var now, result, _i, _a, issue;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            now = new Date();
                            return [4 /*yield*/, client.fetchAllIssuesAndPRsRaw(repo)];
                        case 1:
                            result = _b.sent();
                            _b.label = 2;
                        case 2:
                            if (!true) return [3 /*break*/, 10];
                            _i = 0, _a = result.page;
                            _b.label = 3;
                        case 3:
                            if (!(_i < _a.length)) return [3 /*break*/, 6];
                            issue = _a[_i];
                            return [4 /*yield*/, saveIssueOrPR(issue, now)];
                        case 4:
                            _b.sent();
                            _b.label = 5;
                        case 5:
                            _i++;
                            return [3 /*break*/, 3];
                        case 6:
                            if (!result.next) return [3 /*break*/, 8];
                            now = new Date();
                            return [4 /*yield*/, result.next()];
                        case 7:
                            result = _b.sent();
                            return [3 /*break*/, 9];
                        case 8: return [2 /*return*/];
                        case 9: return [3 /*break*/, 2];
                        case 10: return [2 /*return*/];
                    }
                });
            });
        }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!updateCache()) return [3 /*break*/, 2];
                    log("Cache is too far out of date; running a full issue fetch");
                    return [4 /*yield*/, fullFetch()];
                case 1:
                    _a.sent();
                    log("Full issue fetch complete");
                    return [3 /*break*/, 3];
                case 2:
                    log("Sync completed");
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.default = syncRepoCache;
