"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var https = require("https");
var github_1 = require("./github");
var build_path_1 = require("./build-path");
var oauthToken;
function initialize(_oauthToken) {
    oauthToken = _oauthToken;
}
exports.initialize = initialize;
var me;
function getMyLogin() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!(me === undefined)) return [3 /*break*/, 2];
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', '/user')];
                case 1:
                    me = _b.apply(_a, [_c.sent()]).login;
                    _c.label = 2;
                case 2: return [2 /*return*/, me];
            }
        });
    });
}
exports.getMyLogin = getMyLogin;
function addLabels(issue, labels) {
    return __awaiter(this, void 0, void 0, function () {
        var body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = JSON.stringify(labels);
                    return [4 /*yield*/, exec("POST", build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'labels'), { body: body })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.addLabels = addLabels;
function removeLabels(issue, labels) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, labels_1, label;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _i = 0, labels_1 = labels;
                    _a.label = 1;
                case 1:
                    if (!(_i < labels_1.length)) return [3 /*break*/, 4];
                    label = labels_1[_i];
                    return [4 /*yield*/, exec("DELETE", build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'labels', label))];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.removeLabels = removeLabels;
function setLabels(issue, labels) {
    return __awaiter(this, void 0, void 0, function () {
        var body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = JSON.stringify(labels);
                    return [4 /*yield*/, exec("PUT", build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'labels'), { body: body })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.setLabels = setLabels;
function lockIssue(issue) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('PUT', build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'lock'), { body: "" })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.lockIssue = lockIssue;
function unlockIssue(issue) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('DELETE', build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'lock'))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.unlockIssue = unlockIssue;
function closeIssue(issue) {
    return __awaiter(this, void 0, void 0, function () {
        var body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = JSON.stringify({ state: 'closed' });
                    return [4 /*yield*/, exec('PATCH', build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number), { body: body })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.closeIssue = closeIssue;
function reopenIssue(issue) {
    return __awaiter(this, void 0, void 0, function () {
        var body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = JSON.stringify({ state: 'open' });
                    return [4 /*yield*/, exec('PATCH', build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number), { body: body })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.reopenIssue = reopenIssue;
function addComment(issue, body) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('POST', build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'comments'), { body: JSON.stringify({ body: body }) })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.addComment = addComment;
function editComment(comment, body) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('PATCH', build_path_1.default('repos', comment.repository.owner, comment.repository.name, 'issues', 'comments', comment.id), { body: JSON.stringify({ body: body }) })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.editComment = editComment;
function fetchAllIssuesAndPRsRaw(repo) {
    return __awaiter(this, void 0, void 0, function () {
        function fetchPage(page) {
            return __awaiter(this, void 0, void 0, function () {
                var timestamp, queryString, thisPage, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            timestamp = new Date();
                            queryString = {
                                sort: 'created',
                                filter: 'all',
                                direction: 'asc',
                                per_page: 100,
                                page: page
                            };
                            _b = (_a = JSON).parse;
                            return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'issues'), { queryString: queryString })];
                        case 1:
                            thisPage = _b.apply(_a, [_c.sent()]);
                            return [2 /*return*/, {
                                    page: thisPage,
                                    next: thisPage.length === 100 ? (function () { return fetchPage(page + 1); }) : undefined
                                }];
                    }
                });
            });
        }
        return __generator(this, function (_a) {
            return [2 /*return*/, fetchPage(1)];
        });
    });
}
exports.fetchAllIssuesAndPRsRaw = fetchAllIssuesAndPRsRaw;
function fetchChangedIssuesRaw(repo) {
    return __awaiter(this, void 0, void 0, function () {
        var queryString, page, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    queryString = {
                        sort: 'updated',
                        filter: 'all',
                        direction: 'desc',
                        per_page: 100
                    };
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'issues'), { queryString: queryString })];
                case 1:
                    page = _b.apply(_a, [_c.sent()]);
                    page = page.filter(function (i) { return !i.pull_request; });
                    return [2 /*return*/, page];
            }
        });
    });
}
exports.fetchChangedIssuesRaw = fetchChangedIssuesRaw;
function runQuery(q, callback) {
    return __awaiter(this, void 0, void 0, function () {
        var count, pageNumber, repo, queryString, ref, page, _a, _b, _i, page_1, item, pr;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!(q.kind === "prs")) return [3 /*break*/, 9];
                    count = 0;
                    pageNumber = 1;
                    repo = github_1.parseBasicRepoReference(q.repo);
                    _c.label = 1;
                case 1:
                    if (!true) return [3 /*break*/, 8];
                    queryString = {
                        sort: q.sort,
                        state: q.state,
                        direction: q.direction,
                        per_page: 100,
                        page: pageNumber
                    };
                    ref = github_1.parseBasicRepoReference(q.repo);
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', ref.owner, ref.name, 'pulls'), { queryString: queryString })];
                case 2:
                    page = _b.apply(_a, [_c.sent()]);
                    _i = 0, page_1 = page;
                    _c.label = 3;
                case 3:
                    if (!(_i < page_1.length)) return [3 /*break*/, 7];
                    item = page_1[_i];
                    return [4 /*yield*/, github_1.PullRequest.fromReference(repo, item.number)];
                case 4:
                    pr = _c.sent();
                    return [4 /*yield*/, callback(pr)];
                case 5:
                    _c.sent();
                    count++;
                    if (count === q.count)
                        return [2 /*return*/];
                    _c.label = 6;
                case 6:
                    _i++;
                    return [3 /*break*/, 3];
                case 7:
                    // Exhausted the query
                    if (page.length < 100)
                        return [2 /*return*/];
                    pageNumber++;
                    return [3 /*break*/, 1];
                case 8: return [3 /*break*/, 10];
                case 9: throw new Error("Other query kinds NYI");
                case 10: return [2 /*return*/];
            }
        });
    });
}
exports.runQuery = runQuery;
function fetchChangedPRsRaw(repo) {
    return __awaiter(this, void 0, void 0, function () {
        var queryString, page, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    queryString = {
                        sort: 'updated',
                        state: 'all',
                        direction: 'desc',
                        per_page: 100
                    };
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'pulls'), { queryString: queryString })];
                case 1:
                    page = _b.apply(_a, [_c.sent()]);
                    return [2 /*return*/, page];
            }
        });
    });
}
exports.fetchChangedPRsRaw = fetchChangedPRsRaw;
var ProjectsPreview = "application/vnd.github.inertia-preview+json";
function fetchProjectColumns(projectId) {
    return __awaiter(this, void 0, void 0, function () {
        var raw;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('GET', build_path_1.default('projects', projectId, 'columns'), { preview: ProjectsPreview })];
                case 1:
                    raw = _a.sent();
                    return [2 /*return*/, JSON.parse(raw)];
            }
        });
    });
}
exports.fetchProjectColumns = fetchProjectColumns;
function fetchProjectColumnCards(columnId) {
    return __awaiter(this, void 0, void 0, function () {
        var raw;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('GET', build_path_1.default('projects', 'columns', columnId, 'cards'), { preview: ProjectsPreview })];
                case 1:
                    raw = _a.sent();
                    return [2 /*return*/, JSON.parse(raw)];
            }
        });
    });
}
exports.fetchProjectColumnCards = fetchProjectColumnCards;
function createProjectCard(columnId, issue) {
    return __awaiter(this, void 0, void 0, function () {
        var body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    body = JSON.stringify({ content_id: issue.id, content_type: 'Issue' });
                    return [4 /*yield*/, exec('POST', build_path_1.default('projects', 'columns', columnId, 'cards'), {
                            preview: ProjectsPreview,
                            body: body
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.createProjectCard = createProjectCard;
function moveProjectCard(card, targetColumn) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('POST', build_path_1.default('projects', 'columns', 'cards', card.id, 'moves'), {
                        preview: ProjectsPreview,
                        body: JSON.stringify({
                            position: 'bottom',
                            column_id: targetColumn.columnId
                        })
                    })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.moveProjectCard = moveProjectCard;
function deleteProjectCard(card) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec('DELETE', build_path_1.default('projects', 'columns', 'cards', card.id), {
                        preview: ProjectsPreview
                    })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.deleteProjectCard = deleteProjectCard;
function fetchIssueComments(issue) {
    return __awaiter(this, void 0, void 0, function () {
        var raw;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execPaged(build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'issues', issue.number, 'comments'))];
                case 1:
                    raw = _a.sent();
                    return [2 /*return*/, raw];
            }
        });
    });
}
exports.fetchIssueComments = fetchIssueComments;
function fetchPRCommits(issue) {
    return __awaiter(this, void 0, void 0, function () {
        var raw;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execPaged(build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'pulls', issue.number, 'commits'))];
                case 1:
                    raw = _a.sent();
                    return [2 /*return*/, raw];
            }
        });
    });
}
exports.fetchPRCommits = fetchPRCommits;
function fetchPRFiles(issue) {
    return __awaiter(this, void 0, void 0, function () {
        var raw;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execPaged(build_path_1.default('repos', issue.repository.owner, issue.repository.name, 'pulls', issue.number, 'files'))];
                case 1:
                    raw = _a.sent();
                    return [2 /*return*/, raw];
            }
        });
    });
}
exports.fetchPRFiles = fetchPRFiles;
function fetchIssueCommentReactions(repo, commentId) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'issues', 'comments', commentId, 'reactions'))];
                case 1:
                    result = _b.apply(_a, [_c.sent()]);
                    console.log(result);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.fetchIssueCommentReactions = fetchIssueCommentReactions;
function fetchPR(repo, number) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'pulls', number))];
                case 1:
                    result = _b.apply(_a, [_c.sent()]);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.fetchPR = fetchPR;
function fetchIssue(repo, number) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'issues', number))];
                case 1:
                    result = _b.apply(_a, [_c.sent()]);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.fetchIssue = fetchIssue;
function fetchPRReviews(repo, number) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'pulls', number, 'reviews'), { preview: "application/vnd.github.black-cat-preview+json" })];
                case 1:
                    result = _b.apply(_a, [_c.sent()]);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.fetchPRReviews = fetchPRReviews;
function fetchRefStatusSummary(repo, ref) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, exec('GET', build_path_1.default('repos', repo.owner, repo.name, 'commits', ref, 'status'))];
                case 1:
                    result = _b.apply(_a, [_c.sent()]);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.fetchRefStatusSummary = fetchRefStatusSummary;
function execPaged(path, perPage, queryString) {
    if (perPage === void 0) { perPage = 100; }
    if (queryString === void 0) { queryString = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var result, pageNumber, qs, page, arr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    result = [];
                    pageNumber = 1;
                    _a.label = 1;
                case 1:
                    if (!true) return [3 /*break*/, 3];
                    console.log("Fetch page " + pageNumber + "...");
                    qs = __assign({}, queryString, { page: pageNumber.toString(), per_page: perPage.toString() });
                    return [4 /*yield*/, exec('GET', path, { queryString: qs })];
                case 2:
                    page = _a.sent();
                    arr = JSON.parse(page);
                    if (!Array.isArray(arr)) {
                        throw new Error("Didn't parse an array from a paged fetch");
                    }
                    result.push.apply(result, arr);
                    if (arr.length < perPage) {
                        return [2 /*return*/, result];
                    }
                    pageNumber++;
                    return [3 /*break*/, 1];
                case 3: return [2 /*return*/];
            }
        });
    });
}
var lastRateLimit = 5000;
var lastRateLimitRemaining = 5000;
function exec(method, path, opts) {
    return __awaiter(this, void 0, void 0, function () {
        var hostname, headers, bodyStream, fullPath;
        return __generator(this, function (_a) {
            opts = opts || {};
            hostname = "api.github.com";
            headers = {
                "User-Agent": "RyanCavanaugh idembot",
                "Accept": opts.preview || "application/vnd.github.squirrel-girl-preview+json",
                "Authorization": "token " + oauthToken
            };
            bodyStream = opts.body === undefined ? undefined : Buffer.from(opts.body);
            if (bodyStream !== undefined) {
                headers["Content-Type"] = "application/json";
                headers["Content-Length"] = bodyStream.length;
            }
            fullPath = path;
            if (opts.queryString && Object.keys(opts.queryString).length > 0) {
                fullPath = fullPath + '?' + Object.keys(opts.queryString).map(function (k) { return k + '=' + encodeURIComponent(opts.queryString[k]); }).join('&');
            }
            console.log("[" + lastRateLimitRemaining + " / " + lastRateLimit + "] HTTPS: " + method + " https://" + hostname + fullPath);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    var req = https.request({
                        method: method,
                        path: fullPath,
                        headers: headers,
                        hostname: hostname,
                    }, function (res) {
                        // console.log('Headers: ' + JSON.stringify(res.headers, undefined, 2));
                        lastRateLimit = +(res.headers['x-ratelimit-limit']);
                        lastRateLimitRemaining = +(res.headers['x-ratelimit-remaining']);
                        if (res.statusCode >= 400) {
                            console.log("Error! Status code " + res.statusCode + " returned");
                            reject("Status code " + res.statusCode + " returned");
                            return;
                        }
                        res.setEncoding('utf8');
                        var data = '';
                        res.on('data', function (chunk) {
                            data = data + chunk;
                        });
                        res.on('end', function () {
                            resolve(data);
                        });
                        res.on('error', function (err) {
                            console.log('Connection Error!');
                            console.log(err);
                            reject(err);
                        });
                    });
                    if (bodyStream !== undefined) {
                        req.write(bodyStream);
                    }
                    req.end();
                })];
        });
    });
}
exports.exec = exec;
