"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var sleep = require("sleep-promise");
var client = require("./client");
var weak_string_map_1 = require("./weak-string-map");
var actionRunner_1 = require("./actionRunner");
var moment = require("moment");
var Actions = require("./action");
var build_path_1 = require("./build-path");
function useCache(c) {
    cache = c;
}
exports.useCache = useCache;
var cache = undefined;
function parseDate(s) {
    if (s === null)
        return null;
    return moment(new Date(s));
}
function parseBasicRepoReference(ownerSlashName) {
    var m = /(\w+)\/(\w+)/.exec(ownerSlashName);
    if (!m) {
        throw new Error("Expected \"" + ownerSlashName + "\" to be in format \"owner/name\"");
    }
    return Repository.create(m[1], m[2]);
}
exports.parseBasicRepoReference = parseBasicRepoReference;
function parseRepoReferenceFromURL(url) {
    // https://api.github.com/repos/octocat/Hello-World/something
    var regex = /^https:\/\/[^\/]+\/repos\/([^\/]+)\/([^\/]+)/;
    var match = regex.exec(url);
    if (match == null) {
        throw new Error("Repository URL was in an unexpected format: " + url);
    }
    return Repository.create(match[1], match[2]);
}
exports.parseRepoReferenceFromURL = parseRepoReferenceFromURL;
var User = (function () {
    function User(originalData) {
        this.originalData = originalData;
        this.update(originalData);
    }
    User.fromLogin = function (login) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, User.pool.fromKey(login)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    User.fromData = function (data) {
        return User.pool.fromData(data);
    };
    User.getCacheKey = function (login) {
        return "users/" + login;
    };
    User.prototype.getCacheKey = function () {
        return User.getCacheKey(this.login);
    };
    User.prototype.update = function (data) {
        Object.assign(this, {
            login: data.login
        });
    };
    return User;
}());
User.pool = createPool({
    fetchData: function (login) { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, client.exec('GET', build_path_1.default('users', login))];
                case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
            }
        });
    }); },
    construct: function (data) { return new User(data); },
    keyFromData: function (data) { return data.login; }
});
exports.User = User;
var Label = (function () {
    function Label(repo, data) {
        this.repo = repo;
        this.update([repo, data]);
    }
    Label.fromData = function (repo, data) {
        return Label.pool.fromData([repo, data]);
    };
    Label.prototype.update = function (data) {
        Object.assign(this, { name: data[1].name, color: data[1].color });
    };
    return Label;
}());
Label.pool = createPool({
    fetchData: function (key) { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, client.exec('GET', build_path_1.default('repos', key[0].owner, key[0].name, 'labels', key[1]))];
                case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
            }
        });
    }); },
    construct: function (data) { return new Label(data[0], data[1]); },
    keyFromData: function (data) { return [data[0], data[1].name]; }
});
exports.Label = Label;
var IssueComment = (function () {
    function IssueComment(originalData, issue) {
        this.originalData = originalData;
        this.issue = issue;
        this.update(originalData);
    }
    IssueComment.fromData = function (originalData, issue) {
        return new IssueComment(originalData, issue);
    };
    IssueComment.prototype.update = function (data) {
        Object.assign(this, {
            id: data.id,
            user: User.fromData(data.user),
            created_at: parseDate(data.created_at),
            updated_at: parseDate(data.updated_at),
            body: data.body,
            repository: parseRepoReferenceFromURL(data.issue_url)
        });
    };
    IssueComment.prototype.getReactions = function () {
        return __awaiter(this, void 0, void 0, function () {
            var reactions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchIssueCommentReactions(parseRepoReferenceFromURL(this.originalData.url), this.id)];
                    case 1:
                        reactions = _a.sent();
                        return [2 /*return*/, reactions];
                }
            });
        });
    };
    return IssueComment;
}());
exports.IssueComment = IssueComment;
var Milestone = (function () {
    function Milestone(originalData) {
        this.originalData = originalData;
        Object.assign(this, {
            id: originalData.id,
            number: originalData.number,
            title: originalData.title,
            description: originalData.description,
            state: originalData.state
        });
        this.creator = User.fromData(originalData.creator);
        this.created_at = parseDate(originalData.created_at);
        this.updated_at = parseDate(originalData.updated_at);
        this.closed_at = parseDate(originalData.closed_at);
        this.due_on = parseDate(originalData.closed_at);
    }
    return Milestone;
}());
exports.Milestone = Milestone;
var Repository = (function () {
    function Repository(owner, name) {
        this.owner = owner;
        this.name = name;
    }
    Repository.create = function (owner, name) {
        var key = owner + '/' + name;
        var result = Repository.cache.get(key);
        if (result === undefined) {
            var repo = new Repository(owner, name);
            Repository.cache.set(key, repo);
            return repo;
        }
        return result;
    };
    Object.defineProperty(Repository.prototype, "reference", {
        get: function () {
            return { name: this.name, owner: this.name };
        },
        enumerable: true,
        configurable: true
    });
    return Repository;
}());
Repository.cache = new weak_string_map_1.default();
exports.Repository = Repository;
var IssueOrPullRequest = (function () {
    function IssueOrPullRequest(originalData) {
        var _this = this;
        this.originalData = originalData;
        // Copy some fields
        Object.assign(this, {
            number: originalData.number,
            id: originalData.id,
            title: originalData.title,
            body: originalData.body,
            state: originalData.state,
            locked: originalData.locked,
            html_url: originalData.html_url
        });
        this.repository = parseRepoReferenceFromURL(originalData.url);
        // Parse some dates
        this.created_at = parseDate(originalData.created_at);
        this.updated_at = parseDate(originalData.updated_at);
        this.closed_at = parseDate(originalData.closed_at);
        // Intern some instances
        this.user = User.fromData(originalData.user);
        this.labels = originalData.labels ? originalData.labels.map(function (l) { return Label.fromData(_this.repository, l); }) : [];
        this.assignees = originalData.assignees.map(function (user) { return User.fromData(user); });
    }
    IssueOrPullRequest.fromData = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!data.pull_request) return [3 /*break*/, 2];
                        return [4 /*yield*/, PullRequest.fromReference(parseRepoReferenceFromURL(data.url), data.number)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [4 /*yield*/, Issue.fromIssueData(data)];
                    case 3: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    IssueOrPullRequest.getCacheKey = function (repo, number, isPR) {
        return IssueOrPullRequest.getCacheKeyBasePath(repo, number, isPR) + '.json';
    };
    IssueOrPullRequest.getCommentsCacheKey = function (repo, number, isPR) {
        return IssueOrPullRequest.getCacheKeyBasePath(repo, number, isPR) + '.comments.json';
    };
    IssueOrPullRequest.getCacheKeyBasePath = function (repo, number, isPR) {
        var kind = isPR ? "pull_requests" : "issues";
        // 0000, 1000, 2000, etc
        var thousands = Math.floor(number / 1000) + "000";
        // e.g. Microsoft/TypeScript/issues/3000/3123
        return repo.owner + "/" + repo.name + "/" + kind + "/" + thousands + "/" + number;
    };
    Object.defineProperty(IssueOrPullRequest.prototype, "fullName", {
        /** Returns a string like 'Microsoft/TypeScript#14' */
        get: function () {
            return this.repository.owner + "/" + this.repository.name + "#" + this.number;
        },
        enumerable: true,
        configurable: true
    });
    IssueOrPullRequest.prototype.update = function () {
        // TODO: impl
    };
    IssueOrPullRequest.prototype.getComments = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchIssueComments(this)];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data.map(function (raw) { return IssueComment.fromData(raw, _this); })];
                }
            });
        });
    };
    /**
    * Adds a label to an issue or PR.
    */
    IssueOrPullRequest.prototype.addLabel = function () {
        var labels = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            labels[_i] = arguments[_i];
        }
        return actionRunner_1.addAction(new Actions.Labels.Add(this, labels));
    };
    /**
     * Adds labels to an issue or PR.
     */
    IssueOrPullRequest.prototype.addLabels = function (labels) {
        return actionRunner_1.addAction(new Actions.Labels.Add(this, labels));
    };
    /**
     * Deletes a label from an issue.
     */
    IssueOrPullRequest.prototype.removeLabel = function () {
        var labels = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            labels[_i] = arguments[_i];
        }
        return actionRunner_1.addAction(new Actions.Labels.Remove(this, labels));
    };
    /**
     * Deletes labels from an issue.
     */
    IssueOrPullRequest.prototype.removeLabels = function (labels) {
        return actionRunner_1.addAction(new Actions.Labels.Remove(this, labels));
    };
    /**
     * Sets, exactly, which labels are on an issue
     */
    IssueOrPullRequest.prototype.setLabels = function () {
        var labels = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            labels[_i] = arguments[_i];
        }
        return actionRunner_1.addAction(new Actions.Labels.Set(this, labels));
    };
    /**
     * Shortcut method for setting/clearing labels with an object literal, e.g.
     * issue.setHasLabels({
     *  "Needs Info": false,
     *  "Ready for Triage": true
     * }).
     * You can specify a null value to cause nothing to happen either way
     */
    IssueOrPullRequest.prototype.setHasLabels = function (labelMap) {
        for (var _i = 0, _a = Object.keys(labelMap); _i < _a.length; _i++) {
            var key = _a[_i];
            var value = labelMap[key];
            if (value === true) {
                this.addLabel(key);
            }
            else if (value === false) {
                this.removeLabel(key);
            }
        }
    };
    /**
     * Returns true if this issue has the specified label
     */
    IssueOrPullRequest.prototype.hasLabel = function (labelName) {
        var name = typeof labelName === 'string' ? labelName : labelName.name;
        return this.labels.some(function (l) { return l.name === name; });
    };
    /**
     * Adds or updates a comment with the specified slug to the issue
     */
    IssueOrPullRequest.prototype.addComment = function (slug, body) {
        return actionRunner_1.addAction(new Actions.Comments.Add(this, slug, body));
    };
    IssueOrPullRequest.prototype.lock = function () {
        return actionRunner_1.addAction(new Actions.Issues.Lock(this));
    };
    IssueOrPullRequest.prototype.unlock = function () {
        return actionRunner_1.addAction(new Actions.Issues.Unlock(this));
    };
    IssueOrPullRequest.prototype.close = function () {
        return actionRunner_1.addAction(new Actions.Issues.Close(this));
    };
    IssueOrPullRequest.prototype.reopen = function () {
        return actionRunner_1.addAction(new Actions.Issues.Reopen(this));
    };
    return IssueOrPullRequest;
}());
exports.IssueOrPullRequest = IssueOrPullRequest;
var Issue = (function (_super) {
    __extends(Issue, _super);
    function Issue(data) {
        var _this = _super.call(this, data) || this;
        _this.isPullRequest = false;
        return _this;
    }
    Issue.fromData = function (data) {
        throw new Error("Don't call me");
    };
    Issue.fromIssueData = function (data) {
        return new Issue(data);
    };
    return Issue;
}(IssueOrPullRequest));
exports.Issue = Issue;
var PullRequest = (function (_super) {
    __extends(PullRequest, _super);
    function PullRequest(prData, issueData) {
        var _this = _super.call(this, issueData) || this;
        _this.isPullRequest = true;
        Object.assign(_this, {
            merge_commit_sha: prData.merge_commit_sha,
            merged: prData.merged,
            mergeable: prData.mergeable,
            mergeable_state: prData.mergeable_state,
            comments: prData.comments,
            commits: prData.commits,
            additions: prData.additions,
            deletions: prData.deletions,
            changed_files: prData.changed_files,
            head: prData.head
        });
        return _this;
    }
    PullRequest.fromReference = function (repo, number) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = PullRequest.bind;
                        return [4 /*yield*/, client.fetchPR(repo, number)];
                    case 1:
                        _b = [void 0, _c.sent()];
                        return [4 /*yield*/, client.fetchIssue(repo, number)];
                    case 2: return [2 /*return*/, new (_a.apply(PullRequest, _b.concat([_c.sent()])))()];
                }
            });
        });
    };
    PullRequest.fromData = function (data) {
        throw new Error("Don't call me");
    };
    PullRequest.getPRCacheKey = function (repo, number, isPR) {
        return IssueOrPullRequest.getCacheKeyBasePath(repo, number, isPR) + 'pr.json';
    };
    // TODO interning
    PullRequest.fromIssueAndPRData = function (prData, issueData) {
        return __awaiter(this, void 0, void 0, function () {
            var issueKey, prKey, prCached, issueCached, cachedPR, cachedIssue;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        issueKey = this.getCacheKey(parseRepoReferenceFromURL(prData.url), prData.number, true);
                        prKey = this.getPRCacheKey(parseRepoReferenceFromURL(prData.url), prData.number, true);
                        if (!cache) return [3 /*break*/, 3];
                        return [4 /*yield*/, cache.load(prKey)];
                    case 1:
                        prCached = _a.sent();
                        return [4 /*yield*/, cache.load(issueKey)];
                    case 2:
                        issueCached = _a.sent();
                        if (prCached.exists && issueCached.exists) {
                            cachedPR = prCached.content;
                            cachedIssue = issueCached.content;
                            if (cachedPR.updated_at === prData.updated_at) {
                                return [2 /*return*/, PullRequest.fromPullRequestData(cachedPR, cachedIssue)];
                            }
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/, PullRequest.fromPullRequestData(prData, issueData)];
                }
            });
        });
    };
    // TODO interning
    PullRequest.fromPullRequestData = function (prData, issueData) {
        return new PullRequest(prData, issueData);
    };
    PullRequest.prototype.getStatusSummary = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchRefStatusSummary(this.repository.reference, this.head.sha)];
                    case 1: 
                    // GET /repos/:owner/:repo/commits/:ref/status
                    return [2 /*return*/, (_a.sent()).state];
                }
            });
        });
    };
    PullRequest.prototype.getStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchRefStatusSummary(this.repository.reference, this.head.sha)];
                    case 1: 
                    // GET /repos/:owner/:repo/commits/:ref/status
                    return [2 /*return*/, (_a.sent())];
                }
            });
        });
    };
    PullRequest.prototype.getReviews = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchPRReviews(this.repository.reference, this.number)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    PullRequest.prototype.getCommitsRaw = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchPRCommits(this)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    PullRequest.prototype.getFilesRaw = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchPRFiles(this)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    PullRequest.prototype.getMergeableState = function () {
        return __awaiter(this, void 0, void 0, function () {
            var retryCounter, newData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.merged) {
                            return [2 /*return*/, null];
                        }
                        retryCounter = 5;
                        _a.label = 1;
                    case 1:
                        if (!(this.mergeable === null && retryCounter > 0)) return [3 /*break*/, 6];
                        return [4 /*yield*/, client.fetchPR(this.repository.reference, this.number)];
                    case 2:
                        newData = _a.sent();
                        ;
                        if (!(newData.mergeable === null)) return [3 /*break*/, 4];
                        console.log("Sleep 3 seconds and try to get real mergeable state of " + this.number);
                        return [4 /*yield*/, sleep(3000)];
                    case 3:
                        _a.sent();
                        retryCounter--;
                        return [3 /*break*/, 5];
                    case 4:
                        this.mergeable = newData.mergeable;
                        return [3 /*break*/, 6];
                    case 5: return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, this.mergeable];
                }
            });
        });
    };
    return PullRequest;
}(IssueOrPullRequest));
exports.PullRequest = PullRequest;
var Project = (function () {
    function Project(projectId, columns) {
        this.projectId = projectId;
        this.columns = columns;
    }
    Project.create = function (projectId) {
        return __awaiter(this, void 0, void 0, function () {
            var columnsRaw, columns, _i, columnsRaw_1, raw, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, client.fetchProjectColumns(projectId)];
                    case 1:
                        columnsRaw = _c.sent();
                        columns = [];
                        _i = 0, columnsRaw_1 = columnsRaw;
                        _c.label = 2;
                    case 2:
                        if (!(_i < columnsRaw_1.length)) return [3 /*break*/, 5];
                        raw = columnsRaw_1[_i];
                        _b = (_a = columns).push;
                        return [4 /*yield*/, ProjectColumn.create(raw.id, raw.name)];
                    case 3:
                        _b.apply(_a, [_c.sent()]);
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, new Project(projectId, columns)];
                }
            });
        });
    };
    Project.prototype.setIssueColumn = function (issue, targetColumn) {
        return actionRunner_1.addAction(new Actions.Issues.SetColumn(issue, this, targetColumn));
    };
    Project.prototype.doSetIssueColumn = function (issue, targetColumn) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, sourceColumn, card;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _i = 0, _a = this.columns;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 7];
                        sourceColumn = _a[_i];
                        card = sourceColumn.findProjectCardForIssue(issue);
                        if (!(card !== undefined)) return [3 /*break*/, 6];
                        if (!(targetColumn === undefined)) return [3 /*break*/, 3];
                        return [4 /*yield*/, client.deleteProjectCard(card)];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 3:
                        if (!(targetColumn.columnId !== sourceColumn.columnId)) return [3 /*break*/, 5];
                        return [4 /*yield*/, client.moveProjectCard(card, targetColumn)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5: return [2 /*return*/];
                    case 6:
                        _i++;
                        return [3 /*break*/, 1];
                    case 7:
                        if (!(targetColumn !== undefined)) return [3 /*break*/, 9];
                        return [4 /*yield*/, client.createProjectCard(targetColumn.columnId, issue)];
                    case 8:
                        _b.sent();
                        _b.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    Project.prototype.findColumnByName = function (name) {
        for (var _i = 0, _a = this.columns; _i < _a.length; _i++) {
            var c = _a[_i];
            if (typeof name === 'string') {
                if (c.name === name) {
                    return c;
                }
            }
            else if (name.test(c.name)) {
                return c;
            }
        }
        return undefined;
    };
    return Project;
}());
exports.Project = Project;
var ProjectColumn = (function () {
    function ProjectColumn(columnId, name, cards) {
        this.columnId = columnId;
        this.name = name;
        this.cards = cards.map(function (c) { return new ProjectCard(c); });
    }
    ProjectColumn.create = function (columnId, name) {
        return __awaiter(this, void 0, void 0, function () {
            var cards;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, client.fetchProjectColumnCards(columnId)];
                    case 1:
                        cards = _a.sent();
                        return [2 /*return*/, new ProjectColumn(columnId, name, cards)];
                }
            });
        });
    };
    ProjectColumn.prototype.findProjectCardForIssue = function (issue) {
        for (var _i = 0, _a = this.cards; _i < _a.length; _i++) {
            var card = _a[_i];
            if (issue.number === card.getIssueNumber()) {
                return card;
            }
        }
        return undefined;
    };
    return ProjectColumn;
}());
exports.ProjectColumn = ProjectColumn;
var ProjectCard = (function () {
    function ProjectCard(data) {
        this.data = data;
        this.id = data.id;
    }
    ProjectCard.prototype.getIssueNumber = function () {
        // https://api.github.com/repos/DefinitelyTyped/DefinitelyTyped/issues/17902
        var match = /https:\/\/api.github.com\/repos\/\S+\/\S+\/issues\/(\d+)/.exec(this.data.content_url);
        if (match === null) {
            return undefined;
        }
        else {
            return +(match[1]);
        }
    };
    return ProjectCard;
}());
exports.ProjectCard = ProjectCard;
function createPool(settings) {
    var pool = new weak_string_map_1.default();
    settings.keyToString = settings.keyToString || (function (k) { return k; });
    settings.keyToCacheKey = settings.keyToCacheKey || (function (k) { return k; });
    return ({
        fromKey: function (key) {
            return __awaiter(this, void 0, void 0, function () {
                var keyString, extant, cacheKey, cached, _a, now, data;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            keyString = settings.keyToString(key);
                            extant = pool.get(keyString);
                            if (extant)
                                return [2 /*return*/, extant];
                            cacheKey = settings.keyToCacheKey(key);
                            _a = cache;
                            if (!_a) return [3 /*break*/, 2];
                            return [4 /*yield*/, cache.load(cacheKey)];
                        case 1:
                            _a = (_b.sent());
                            _b.label = 2;
                        case 2:
                            cached = _a;
                            if (cached && cached.exists) {
                                return [2 /*return*/, settings.construct(cached.content)];
                            }
                            now = new Date();
                            return [4 /*yield*/, settings.fetchData(key)];
                        case 3:
                            data = _b.sent();
                            cache && cache.save(data, cacheKey, now);
                            return [2 /*return*/, settings.construct(data)];
                    }
                });
            });
        },
        fromData: function (data) {
            var keyString = settings.keyToString(settings.keyFromData(data));
            var extant = pool.get(keyString);
            if (extant) {
                extant.update(data);
                return extant;
            }
            var result = settings.construct(data);
            pool.set(keyString, result);
            return result;
        }
    });
}
