"use strict";
/// <reference path="github-api.ts" />
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Actions = require("./action");
exports.Actions = Actions;
var client = require("./client");
var logging = require("./logging");
var cache_1 = require("./cache");
var actionRunner_1 = require("./actionRunner");
var GitHubWrapper = require("./github");
var github_1 = require("./github");
var github_2 = require("./github");
exports.User = github_2.User;
exports.Issue = github_2.Issue;
exports.PullRequest = github_2.PullRequest;
exports.Milestone = github_2.Milestone;
exports.Label = github_2.Label;
exports.IssueOrPullRequest = github_2.IssueOrPullRequest;
exports.Project = github_2.Project;
exports.ProjectCard = github_2.ProjectCard;
exports.ProjectColumn = github_2.ProjectColumn;
var log = logging.get('idembot').log;
process.on('unhandledRejection', function (err) {
    console.error(err);
});
function runRulesOn(item, setup) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, _a, ruleName, _b, _c, ruleName, _d, _e, ruleName;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    if (!(setup.rules.issues && !item.isPullRequest)) return [3 /*break*/, 4];
                    _i = 0, _a = Object.keys(setup.rules.issues);
                    _f.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    ruleName = _a[_i];
                    return [4 /*yield*/, runRule(item, setup.rules.issues[ruleName], ruleName)];
                case 2:
                    _f.sent();
                    _f.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4:
                    if (!(setup.rules.pullRequests && item.isPullRequest)) return [3 /*break*/, 8];
                    _b = 0, _c = Object.keys(setup.rules.pullRequests);
                    _f.label = 5;
                case 5:
                    if (!(_b < _c.length)) return [3 /*break*/, 8];
                    ruleName = _c[_b];
                    return [4 /*yield*/, runRule(item, setup.rules.pullRequests[ruleName], ruleName)];
                case 6:
                    _f.sent();
                    _f.label = 7;
                case 7:
                    _b++;
                    return [3 /*break*/, 5];
                case 8:
                    if (!setup.rules.issuesAndPullRequests) return [3 /*break*/, 12];
                    _d = 0, _e = Object.keys(setup.rules.issuesAndPullRequests);
                    _f.label = 9;
                case 9:
                    if (!(_d < _e.length)) return [3 /*break*/, 12];
                    ruleName = _e[_d];
                    return [4 /*yield*/, runRule(item, setup.rules.issuesAndPullRequests[ruleName], ruleName)];
                case 10:
                    _f.sent();
                    _f.label = 11;
                case 11:
                    _d++;
                    return [3 /*break*/, 9];
                case 12: return [2 /*return*/];
            }
        });
    });
}
function runRule(issue, rule, name) {
    return __awaiter(this, void 0, void 0, function () {
        var result, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    result = rule(issue);
                    if (!(result !== undefined)) return [3 /*break*/, 2];
                    return [4 /*yield*/, result];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    log("Rule " + name + " encountered exception running on " + issue.html_url);
                    log(e_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function bot(setup, opts, oauthToken) {
    client.initialize(oauthToken);
    var cache = cache_1.createCache(opts.cacheRoot);
    GitHubWrapper.useCache(cache);
    function runRules() {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var info, issueOrPR_raw, issue, pr, _i, _a, ruleName, _b, _c, ruleName, _d, _e, ruleName, _f, _g, query;
            return __generator(this, function (_h) {
                switch (_h.label) {
                    case 0:
                        info = {
                            log: {}
                        };
                        if (!(opts.kind === 'single')) return [3 /*break*/, 17];
                        return [4 /*yield*/, client.fetchIssue(opts.single, opts.single.id)];
                    case 1:
                        issueOrPR_raw = _h.sent();
                        issue = github_1.Issue.fromIssueData(issueOrPR_raw);
                        pr = undefined;
                        if (!issueOrPR_raw.pull_request) return [3 /*break*/, 3];
                        return [4 /*yield*/, github_1.PullRequest.fromReference(opts.single, opts.single.id)];
                    case 2:
                        pr = _h.sent();
                        _h.label = 3;
                    case 3:
                        console.log("Processing " + opts.single.owner + "/" + opts.single.name + "#" + opts.single.id + ": " + issue.title);
                        if (!(setup.rules.issues && !pr)) return [3 /*break*/, 7];
                        _i = 0, _a = Object.keys(setup.rules.issues);
                        _h.label = 4;
                    case 4:
                        if (!(_i < _a.length)) return [3 /*break*/, 7];
                        ruleName = _a[_i];
                        return [4 /*yield*/, runRule(issue, setup.rules.issues[ruleName], ruleName)];
                    case 5:
                        _h.sent();
                        _h.label = 6;
                    case 6:
                        _i++;
                        return [3 /*break*/, 4];
                    case 7:
                        if (!(setup.rules.pullRequests && pr)) return [3 /*break*/, 11];
                        _b = 0, _c = Object.keys(setup.rules.pullRequests);
                        _h.label = 8;
                    case 8:
                        if (!(_b < _c.length)) return [3 /*break*/, 11];
                        ruleName = _c[_b];
                        return [4 /*yield*/, runRule(pr, setup.rules.pullRequests[ruleName], ruleName)];
                    case 9:
                        _h.sent();
                        _h.label = 10;
                    case 10:
                        _b++;
                        return [3 /*break*/, 8];
                    case 11:
                        if (!setup.rules.issuesAndPullRequests) return [3 /*break*/, 15];
                        _d = 0, _e = Object.keys(setup.rules.issuesAndPullRequests);
                        _h.label = 12;
                    case 12:
                        if (!(_d < _e.length)) return [3 /*break*/, 15];
                        ruleName = _e[_d];
                        return [4 /*yield*/, runRule(issue, setup.rules.issuesAndPullRequests[ruleName], ruleName)];
                    case 13:
                        _h.sent();
                        _h.label = 14;
                    case 14:
                        _d++;
                        return [3 /*break*/, 12];
                    case 15: return [4 /*yield*/, actionRunner_1.runActions(info, opts)];
                    case 16:
                        _h.sent();
                        return [3 /*break*/, 24];
                    case 17:
                        if (!(opts.kind === 'queries')) return [3 /*break*/, 23];
                        _f = 0, _g = opts.queries;
                        _h.label = 18;
                    case 18:
                        if (!(_f < _g.length)) return [3 /*break*/, 21];
                        query = _g[_f];
                        return [4 /*yield*/, client.runQuery(query, function (item) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, runRulesOn(item, setup)];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 19:
                        _h.sent();
                        _h.label = 20;
                    case 20:
                        _f++;
                        return [3 /*break*/, 18];
                    case 21: return [4 /*yield*/, actionRunner_1.runActions(info, opts)];
                    case 22:
                        _h.sent();
                        return [3 /*break*/, 24];
                    case 23: throw new Error('Unreachable?');
                    case 24: return [2 /*return*/];
                }
            });
        });
    }
    return ({
        runRules: runRules
    });
}
exports.default = bot;
