import { Pool } from './pool';
import { Cache } from './cache';
import * as Wrapped from './github';
export declare function useCache(c: Cache): void;
export declare namespace Keys {
    type User = string;
    type Issue = [string, string, number];
    type Label = [string, string, string];
}
export declare const Issues: Pool<[string, string, number], GitHubAPI.Issue, Wrapped.Issue, {}>;
export declare const Users: Pool<string, GitHubAPI.User, Wrapped.User, {}>;
export declare const IssueComments: Pool<{}, GitHubAPI.IssueComment, Wrapped.IssueComment, Wrapped.Issue>;
export declare namespace Labels {
    function get(repo: Wrapped.Repository, data: GitHubAPI.Label): Wrapped.Label;
}
