"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var commander = require("commander");
var fs = require("mz/fs");
var index_1 = require("./index");
var query_parser_1 = require("./query-parser");
var oauth = process.env['AUTH_TOKEN'];
function parseQueryFile(filename) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _a = query_parser_1.parseQuery;
                    _c = (_b = JSON).parse;
                    return [4 /*yield*/, fs.readFile(filename, 'utf-8')];
                case 1: return [2 /*return*/, _a.apply(void 0, [_c.apply(_b, [_d.sent()])])];
            }
        });
    });
}
function main(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var filename, queries, dry, short, single, cacheRoot, rulesMod, _i, _a, rule, ruleNames, parsedOptions, match, owner, name, id, parsedQueries, _b, _c, q, _d, _e, e_1, bot;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    commander
                        .option('-f, --file [filename]', "specify rules filename (default: rules.js)", "rules.js")
                        .option('-d, --dry', "don't actually change anything", false)
                        .option('-r, --rules [rules]', "specify a comma-delimited list of specific rules to run")
                        .option('--ls', "displays a list of rule names and exits")
                        .option('-q, --query [query]', "specify query filenames (comma-delimited, default: query.json)")
                        .option('--single [ref]', "run on the specified issue or PR. Ref: owner/repo#id")
                        .parse(process.argv);
                    commander.usage("idembot --query open-issues.json");
                    if (argv.length < 2) {
                        commander.outputHelp();
                        return [2 /*return*/, 0];
                    }
                    filename = commander['file'];
                    queries = (commander['query'] && commander['query'].split(',')) || [];
                    console.log(queries);
                    dry = !!commander['dry'];
                    short = !!commander['short'];
                    single = commander['single'] || '';
                    cacheRoot = path.join(path.dirname(path.resolve(filename)), 'cache');
                    try {
                        rulesMod = require(path.resolve(filename));
                    }
                    catch (e) {
                        console.log("Failed to load rules module " + filename + ": " + e);
                        return [2 /*return*/, -1];
                    }
                    // Handle --ls mode and exit
                    if (commander['ls']) {
                        console.log("Rules in module " + filename + ":");
                        for (_i = 0, _a = Object.keys(rulesMod.rules); _i < _a.length; _i++) {
                            rule = _a[_i];
                            console.log(" * " + rule);
                        }
                        return [2 /*return*/, 0];
                    }
                    ruleNames = commander['rules'] || Object.keys(rulesMod.rules);
                    if (!(single.length > 0)) return [3 /*break*/, 1];
                    if (queries.length > 0) {
                        console.log('Specify only one of "queries" and "single"');
                        return [2 /*return*/, -1];
                    }
                    match = /(\w+)\/(\w+)#(\w+)/.exec(single);
                    if (!match) {
                        console.log('Specify single in format: owner/name#id');
                        return [2 /*return*/, -1];
                    }
                    owner = match[1], name = match[2], id = match[3];
                    parsedOptions = {
                        cacheRoot: cacheRoot, dry: dry, ruleNames: ruleNames,
                        kind: "single",
                        single: { owner: owner, name: name, id: id }
                    };
                    return [3 /*break*/, 8];
                case 1:
                    parsedQueries = [];
                    if (queries.length === 0)
                        queries.push('query.json');
                    _b = 0, _c = queries || ['query.json'];
                    _f.label = 2;
                case 2:
                    if (!(_b < _c.length)) return [3 /*break*/, 7];
                    q = _c[_b];
                    _f.label = 3;
                case 3:
                    _f.trys.push([3, 5, , 6]);
                    _e = (_d = parsedQueries).push;
                    return [4 /*yield*/, parseQueryFile(q)];
                case 4:
                    _e.apply(_d, [_f.sent()]);
                    return [3 /*break*/, 6];
                case 5:
                    e_1 = _f.sent();
                    console.log("Error parsing query file " + q + ": " + e_1);
                    return [2 /*return*/, -1];
                case 6:
                    _b++;
                    return [3 /*break*/, 2];
                case 7:
                    parsedOptions = {
                        cacheRoot: cacheRoot, dry: dry, ruleNames: ruleNames,
                        kind: "queries",
                        queries: parsedQueries
                    };
                    _f.label = 8;
                case 8:
                    // Check for oauth token
                    if (oauth === undefined) {
                        console.log('You must set the AUTH_TOKEN environment variable to a suitable OAuth token');
                        return [2 /*return*/, -1];
                    }
                    bot = index_1.default(rulesMod, parsedOptions, oauth);
                    return [4 /*yield*/, bot.runRules()];
                case 9:
                    _f.sent();
                    return [2 /*return*/, 0];
            }
        });
    });
}
main(process.argv).then(function (r) { return process.exit(r); });
