"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WeakStringMap = (function () {
    function WeakStringMap() {
        this.keys = {};
        this.map = new WeakMap();
    }
    WeakStringMap.prototype.get = function (s) {
        // No key by that name
        if (!this.keys[s])
            return undefined;
        var result = this.map.get(this.keys[s]);
        if (result === undefined) {
            // Object went missing from the map so delete its corresponding key
            delete this.keys[s];
        }
        return result;
    };
    WeakStringMap.prototype.delete = function (s) {
        if (!this.keys[s])
            return;
        this.map.delete(this.keys[s]);
        delete this.keys[s];
    };
    WeakStringMap.prototype.set = function (s, value) {
        this.keys[s] = this.keys[s] || {};
        this.map.set(this.keys[s], value);
        return this;
    };
    return WeakStringMap;
}());
exports.default = WeakStringMap;
